Блог пользователя awoo

Автор awoo, история, 5 лет назад, По-русски

1207A - Бывает два типа бургеров

Идея: BledDest

Разбор
Решение (Roms)

1207B - Заполнение квадратов

Идея: BledDest

Разбор
Решение (BledDest)

1207C - Газопровод

Идея: adedalic

Разбор
Решение (adedalic)

1207D - Количество перестановок

Идея: Roms

Разбор
Решение (Roms)

1207E - XOR-угадайка

Идея: adedalic, Neon, BledDest

Разбор
Решение (BledDest)

1207F - Задача об остатках

Идея: BledDest

Разбор
Решение (BledDest)

1207G - Инди альбом

Идея: adedalic

Разбор
Решение (PikMike)
  • Проголосовать: нравится
  • +119
  • Проголосовать: не нравится

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится -13 Проголосовать: не нравится

[DELETED]

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In solution for C) editorial says that: If s[pos]=1 then we have to stay on the height 2, but in the sample test 1 8 2 5 00110010 It is optimal to go to height 1, after index 3, where s[3] = 1, and s[4] = 0 (as shown in the problem figure). What am I missing here?

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится +1 Проголосовать: не нравится

    The "s" array in the editorial corresponds to intervals (so s[3] corresponds to the height of the interval (3, 4)), but the dp array "d" corresponds to the height at specific x-values.

    In other words, because s[3] = 1, the road needs to be at height 2 at x=4, meaning that d[4][0] doesn't exist. s[4] = 0 instead means that d[5][0] and d[5][1] are both OK.

»
5 лет назад, # |
  Проголосовать: нравится +15 Проголосовать: не нравится

Огромное спасибо за решения! Каждый раз удивляюсь своему навыку всё усложнять ...

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I didn't get the 2nd query of F ? What sum is supposed to calculate ?

»
5 лет назад, # |
  Проголосовать: нравится +14 Проголосовать: не нравится

During contest, after solving first 5 problems, spent 1 hour working on problem F looking for a solution which was faster than O(n^(3/2)) because I assumed, incorrectly, that O(n^(3/2)) cannot pass... I even designed an O(n^(4/3)) algorithm to solve a simpler version of the problem where all the numbers are fixed from the beginning and never modified. (The solution is similar to the solution in the editorial except that the value of K is n^(2/3) instead of sqrt(n)). I then spent all the time trying to improve my algorithm to support modification to the sequence...

Honestly, I also felt that problem E was much easier than problem C and D.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится
Can anyone explain more elaborately :
  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    k=4 1 2 3 4 5 6 7 8 then 1 2 3 4 is only possible for <=k and each can have atmost ai-1 remainder, hence total approximately k^2 queries.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

IN ques.D for counting of cnt1,given is cnt1=c1!*c2*!..cn! my doubt is while calculating c1! ,it is not necessary that the corrsponding elements in the another column will be all different and give different permutations..so we must divide it by those factorials..

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Even if you consider the second column, even two sets of identical pairs will need to be considered twice so there is no need to divide.

  • »
    »
    4 года назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    I was thinking the same thing. The third sample case is as follows

    3
    1 1
    1 1
    2 3
    

    The given answer is 4. However, there are only 3 ways to arrange the above pairs (3!/2!). What am I misunderstanding?

    • »
      »
      »
      4 года назад, # ^ |
        Проголосовать: нравится +1 Проголосовать: не нравится

      Permutations->

      1,2,3

      2,1,3.

      So only two bad sequences. Hence 4 good sequences.

      • »
        »
        »
        »
        4 года назад, # ^ |
        Rev. 2   Проголосовать: нравится +1 Проголосовать: не нравится

        I thought 1,2,3 and 2,1,3 shouldn't be counted twice, since they are identical sequences, but the permutations are distinct, so they should be counted separately. Got it, thanks!

»
5 лет назад, # |
  Проголосовать: нравится +27 Проголосовать: не нравится

An online solution to problem G :

We build the suffix automaton for the trie which is given, and then we build a segment tree for every node (endpos set) . For a query, we do the heavy-chain decomposition for the trie, and then we query the segment tree sum.

Total time complexity is $$$\mathrm O(n\log^2n)$$$.

My code : https://codeforces.com/contest/1207/submission/59299826

This method use so much memory that it will get MLE on test 21 (https://codeforces.com/contest/1207/submission/59296517), but you can get AC by replacing the array with std::map.

Sorry for my poor English.

»
5 лет назад, # |
Rev. 3   Проголосовать: нравится +3 Проголосовать: не нравится

The editorial solution for C,

else {
   d[pos + 1][1] = minOf(d[pos + 1][1], d[pos][1] + a + 2 * b)
}

should it be

else {
   d[pos + 1][1] = minOf(d[pos + 1][1], d[pos][1] + a + 2 * b);
   d[pos + 1][1] = minOf(d[pos + 1][1], d[pos][0] + 2 *(a + b));
}

why the solution ignores the 0 to 1 transition when the s[i] == '1'?

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится +3 Проголосовать: не нравится

    When s[i] = '0', there are 4 possibilities, you can reach 'pos+1', that is two transitions each from height 1 and 2.

    When s[i] = '1', there is only one 1 possibility, you can reach 'pos+1', that is using one gas pipeline and 2 pillars.

    Pictorial illustration

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится +3 Проголосовать: не нравится

      but When s[i] = '1', why it can not be height 1 to height 2 transition? which uses 2 pipes and 2 pillar

      • »
        »
        »
        »
        5 лет назад, # ^ |
        Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

        Because you can only have zig-zagged line in the interval (i, i+1) when s[i] = '0', when s[i] = '1', you cannot break the line, it must be linear coming from the left side. Hence you can only modify dp[i+1][1].

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

I am getting wrong Answer on Test 13 in Problem 1207C Gas Pipeline. My logic is that i am using dp[j][0] which is the cost to bring pipeline to height 1 at position j and dp[j][1] for cost to bring pipeline to height 2 at j. if Character at j is 1 dp[j][0] is -1 which means that it is impossible to bring pipeline to height 1. I am using MAX_VALUE in place of -1 in dp[j-1][0] if dp[j-1][0] is -1 which means it has a very high cost to build the pipeline from there.

Link to my Solution..

https://codeforces.com/contest/1207/submission/59357734

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Can someone tell me why my submission is giving WA for question D. Thanks in advance

https://codeforces.com/contest/1207/submission/59385418

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится
            cout << ((tot - (cnt1 + cnt2 - cnt12))%MOD);
        }
        else{
            cout << ((tot - (cnt1 + cnt2))%MOD);
    

    Here's the mistake. you are subtracting something from modded value. In some case value of tot will be less than (cnt1 + cnt2 — cnt12) or (cnt1 + cnt2) that's why your final answer is landing to negative value.

    replace your lines with below lines.

         cout << (((tot - (cnt1 + cnt2 - cnt12))%MOD)+MOD)%MOD;
        }
        else{
            cout << (((tot - (cnt1 + cnt2))%MOD)+MOD)%MOD;
    
    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Oh right Thanks a lot . After one hour of struggling it was the MOD :p

      • »
        »
        »
        »
        5 лет назад, # ^ |
        Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

        Hey, I understood the approach to calculate c1,c2. Can you elaborate on how to calculate c12.

        It would be much helpful. Thank you :)

»
5 лет назад, # |
  Проголосовать: нравится +2 Проголосовать: не нравится

F is not worth 2100.

  • »
    »
    5 лет назад, # ^ |
    Rev. 3   Проголосовать: нравится -8 Проголосовать: не нравится

    What do you mean? For each problem you get 1 point for solving it.

    UPDATE: OK, I see. Tags with numbers of points have been added.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Could anyone give me a greedy solution for problem C. I came up with this approach in the contest but I can't implement it correctly. Thanks in advance!

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится +13 Проголосовать: не нравится

In the editorial of Problem F it states that: "Note that, as in most problems related to sqrt-heuristics, it may be optimal to choose the constant that is not exactly sqrt(N), but something similar to it (but most solutions should pass without tuning the constant)"

Could anyone please explain why it may not be optimal to choose exactly sqrt(N)?

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится +3 Проголосовать: не нравится

    The two parts of the algorithm have O(K) and O(N/K) complexities but the constant factor will not necessarily be the same (e.g. we do a modulo and use more memory for the small x part and always update K elements, while the naive algorithm for large x just sums N/x values which is only at most N/K... many things to consider).

    Pushing K on one side or the other of sqrt(N) will increase the time spent on one part and reduce the other, so because of the constant factors the optimal sum of complexities might be for 0.7sqrt(N) or 3.5sqrt(N) or whatever. Here sqrt(N) is 750 but experimentaly i got the lowest execution time with K around 400.

    Do people really test this in competition though ? Or just guess and round a bit up or down ?

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

[deleted]

»
5 лет назад, # |
  Проголосовать: нравится -10 Проголосовать: не нравится

I've used greedy approach to solve problem C. It fails on test case 13. Please tell me where it goes wrong. Code

  • »
    »
    23 месяца назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    You have misread the problem like me:) : the problem says that you MUST start and finish the pipeline on height 1. So you don't need to take the case of the height of the pipeline being 2 for the initial zero subarray, and for the final zero subarray.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Please someone explain the problem E !!

I couldn't understand from the editorial.

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится +1 Проголосовать: не нравится

    1) In each query generate numbers in the way to check some bits in any $$$i$$$ case (if we are sure that $$$k_{th}$$$ bit is '1' in choosed number and '0' in answer, then $$$x$$$ has $$$k_{th}$$$ bit also '1', otherwise it is '0' — it follows from the properties of XOR).

    2) Let's fix first $$$a$$$ bits as '1' and choose any combinations in another $$$14 - a$$$ bits. We have to generate $$$100$$$ different combinations, so $$$2^{14 - a}$$$ must be better than $$$100$$$ => $$$14 - a = 7, a = 7$$$ ($$$2^7 = 128 > 100$$$).

    So we fix first $$$7$$$ bits as $$$1111111$$$ and increase another, getting the following sequence: $$$11111110000000_2$$$, $$$11111110000001_2$$$, $$$11111110000010_2$$$ and etc.

    3) Using the same algorithm generate another $$$100$$$ numbers, but visa versa: $$$00000001111111_2$$$, $$$00000011111111_2$$$, $$$00000010111111_2$$$ and etc.

    4) From first query answer we check first $$$7$$$ bits using XOR, from another query answer — last $$$7$$$ bits and finally get complete answer.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Task F is quite easy to solve and code, but statement is quite hard to understand :D

At first I thought that it is necessary to calculate the sum of all elements $$$a_i = k \cdot x + y$$$, not indexes)

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In G instead of adding on path to the root and extracting value from vertex we can do: add to a vertex and calculate sum in a subtree (it can be easily verified to be equivalent)

»
5 лет назад, # |
Rev. 5   Проголосовать: нравится 0 Проголосовать: не нравится

Another solution for problem G:

There are no more than $$$S$$$ = $$$2 \times sqrt(4 \times 10^5)$$$ different lengths in the set of all patterns, say $$$L_1, L_2, ..., L_S$$$.

When DFS to some trie node $$$v$$$, among all different patterns with length $$$L_i$$$, there is at most one occurrence ending at node $$$v$$$.
Therefore, maintaining number of occurrences of all different patterns can be done in $$$O(S)$$$ whenever DFS moves to next vertex.

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Can someone explain how to calculate c12 more elaborately in Div2D?

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

For E

I have an approach but don't know whether it's feasible or not.

Let us denote numbers of $$$1^{st}$$$ query by $$$a_i$$$ and numbers of $$$2^{nd}$$$ query by $$$b_j$$$.So if we select numbers in such a way that xor of any pair ($$$a_i$$$,$$$b_j$$$) is unique. Now let us denote the output to two queries by $$$N$$$ and $$$M$$$ respectively then we can say that $$$N$$$ = $$$a_i \oplus x$$$ and $$$M$$$ = $$$b_j \oplus x$$$.If we now do $$$N \oplus M$$$ then we get $$$a_i \oplus b_j$$$ .Since we selected such numbers that every pair has unique xor we know value of $$$a_i$$$ and $$$b_j$$$ and once we get this we can get $$$x$$$ by $$$N \oplus a_i$$$ or $$$M \oplus b_j$$$.

So my question is there any way to select such numbers that their xor is unique.BledDest

  • »
    »
    8 месяцев назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    I have done it in a similar way. 219922345. The two array elements range till 1e5 at max when started with the Identity element in the first array.

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится +3 Проголосовать: не нравится

Why am I getting runtime error in D? https://codeforces.com/contest/1207/submission/60137631

»
4 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

We can also solve E just by brute-force. lets say we gave two sequence (Ai,Bi) to the judge now it will return Ai^x and Bi^x ,take xor of these values we get Ai^Bi. If we can generate two lists of size 100 such Ai^Bi is distinct for every Ai,Bi. This can be done by brute force (have a look at my submission https://codeforces.com/contest/1207/submission/6769403) Now we know the Ai,Bi hence x will be just Ai^(Ai^x).

»
4 года назад, # |
  Проголосовать: нравится -8 Проголосовать: не нравится

I tried to solve problem C greedily but got WA on test case 13

So please somebody tell me where i am wrong

Solution link : https://codeforces.com/contest/1207/submission/95326809

»
23 месяца назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

So many of us have got WA on test 13(including me) using the greedy approach for Problem C... Anyone figured out why that is the case? Update : found out myself.

»
6 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

What the F is Problem F is asking ? I reuqest Educational Forces to add Notes to Problem Description Such nice problems should definetly have notes